MODULE testdiv ;

FROM SYSTEM IMPORT ADDRESS ;
FROM NumberIO IMPORT WriteCard ;
FROM StrIO IMPORT WriteString, WriteLn ;
FROM StrLib IMPORT StrLen ;


CONST
   ClockFreq = 20 ;

TYPE
   ProcType   = (User, System) ;
 
   ProcStatus = (Runnable, WaitOnSem, WaitOnIO, Suspended, Killed, Sleeping) ;
 
   PtrToProcDes      = POINTER TO ProcessDescriptor ;
   ProcessDescriptor = RECORD
                          RightPtr      : PtrToProcDes ;
                          LeftPtr       : PtrToProcDes ;
                          RightRunPtr   : PtrToProcDes ;
                          LeftRunPtr    : PtrToProcDes ;
                          RightOwner    : PtrToProcDes ;
                          LeftOwner     : PtrToProcDes ;
                          Father        : PtrToProcDes ;
                          Sons          : PtrToProcDes ;
                          PPriority     : CARDINAL ;  (* 0..MaxPriority *)
                          PQuanta       : CARDINAL ;
                          PMemorySize   : CARDINAL ;
                          PMemoryStart  : ADDRESS ;
                          PHeapSize     : CARDINAL ;
                          PHeapStart    : ADDRESS ;
                          PFreeMem      : ADDRESS ;
                          TimeSecs      : CARDINAL ;
                          PName         : ARRAY [0..15] OF CHAR ;
                          Process       : ADDRESS ;
                          PType         : ProcType ;
                          PCurrentStatus: ProcStatus ;
                          PNextStatus   : ProcStatus ;
                       END ;


PROCEDURE WriteProcess (p: PtrToProcDes) ;
VAR
   i : CARDINAL ;
BEGIN
(*
   WriteString( p^.PName ) ;
   i := HIGH( p^.PName )-StrLen( p^.PName ) ;
   WHILE i>0 DO
       WriteString(' ') ;
       DEC( i )
   END ;
*)
   WITH p^ DO
(*
      WriteCard( PMemorySize DIV 1024, 6 ) ;
      WriteString('k   (') ;
      IF PMemorySize#0
      THEN
         WriteCard( (PMemorySize -
                     (CARDINAL(Process) - CARDINAL(PMemoryStart))) * 100
                    DIV PMemorySize, 3)
      ELSE
         WriteString('  0')
      END ;
      WriteString('%)  Pri') ;
      WriteCard( PPriority, 2 ) ;
      WriteCard( PQuanta, 3 ) ;
      WriteString('  ') ;
      WriteString('  ') ;
      WriteString('  ') ;
*)
      WriteCard( (TimeSecs DIV ClockFreq) DIV (60*60), 2 ) ;      (* Hours   *)
      WriteString(':') ;
      WriteCard( ((TimeSecs DIV ClockFreq) DIV 60) MOD 60, 2) ;   (* Minutes *)
      WriteString(':') ;
      WriteCard( (TimeSecs DIV ClockFreq) MOD 60, 2)              (* Seconds *)
   END
END WriteProcess ;


VAR
   TimeSecs: CARDINAL ;
   p       : PtrToProcDes ;
BEGIN
   WriteProcess(p)
END testdiv.
