MODULE list ;


FROM FIO IMPORT OpenToRead, OpenToWrite, Close, EOF, WriteLine,
                ReadString, WriteString, File, WriteChar;
FROM NumberIO IMPORT WriteInt,ReadInt,StrToInt,IntToStr;
FROM FpuIO IMPORT ReadReal,WriteReal,StrToReal,RealToStr;
FROM StdIO IMPORT Write;
IMPORT StrIO; (* WriteString,WriteLn,ReadString; *)
FROM StrLib IMPORT StrLen,StrLess,StrEqual;

TYPE
    string4  = ARRAY[0..3] OF CHAR;
    string8 = ARRAY[0..7] OF CHAR;
    string10 = ARRAY[0..9] OF CHAR;
    string20 = ARRAY[0..19] OF CHAR;
    string40 = ARRAY[0..39] OF CHAR;

   employeeRecordType = RECORD
          Forename : string20;
          Surname  : string40;
          EmpNumber: string10;
          Address1 : string20;
          Address2 : string20;
          Address3 : string20;
          Address4 : string20;
          END;(*record*)

VAR
   filehandle: File ;
   crlf      : ARRAY[0..1] OF CHAR;


PROCEDURE getRecord(VAR employeeRec: employeeRecordType);
BEGIN
   WITH employeeRec DO
      (*Read in each field in turn.*)
      ReadString(filehandle,Surname);
      ReadString(filehandle,Forename);
      ReadString(filehandle,EmpNumber);
      ReadString(filehandle,Address1);
      ReadString(filehandle,Address2);
      ReadString(filehandle,Address3);
      ReadString(filehandle,Address4);
      ReadString(filehandle,crlf);
   END
END getRecord; 


PROCEDURE getFile (nameOfFile : ARRAY OF CHAR) ;
VAR
    inRec : employeeRecordType;
BEGIN
    (*Reset the file to read it all in.*)
    filehandle := OpenToRead(nameOfFile) ;

    (*Process all the lines in the file.*)
    WHILE NOT EOF(filehandle ) DO 
    getRecord(inRec); 
        printEntry(inRec);
    END ; (* WHILE NOT EOF() *)
    Close(filehandle);
END getFile ; 

PROCEDURE printEntry(which : employeeRecordType) ;
BEGIN
    WITH which DO
        (*print each field in turn.*)
        StrIO.WriteString(Forename);
    StrIO.WriteString(" ");
    StrIO.WriteString(Surname);
    StrIO.WriteString(" ");
    StrIO.WriteString(EmpNumber);
    StrIO.WriteLn;
    StrIO.WriteString(Address1);
    StrIO.WriteLn;
    StrIO.WriteString(Address2);
    StrIO.WriteLn;
    StrIO.WriteString(Address3);
    StrIO.WriteLn;
    StrIO.WriteString(Address4);
    END ; (*with*)
StrIO.WriteLn;
END printEntry; (*printEntry*)


BEGIN
   getFile('employee.txt')
END list.
