MODULE impexp ;


FROM DiskIO IMPORT GetNextSymbol, CurrentSymbol, OpenSource,
                   CloseSourceFile, WriteError ;

FROM Args IMPORT GetArg, Narg ;

FROM StrLib IMPORT StrEqual, StrLen ;

FROM StrIO IMPORT WriteString, WriteLn ;


VAR
   CharNo: CARDINAL ;  (* Index into the CurrentSymbol *)
   High  : CARDINAL ;  (* StrLen(CurrentSymbol)        *)


(* InitChar - resets the CharNo. *)

PROCEDURE InitChar ;
BEGIN
   CharNo := 0 ;
   High := StrLen(CurrentSymbol)
END InitChar ;


(* Returns TRUE if current character is ch *)
(*         FALSE otherwise.                *)
(* and increments the CharNo if TRUE       *)

PROCEDURE CharIs (ch: CHAR) : BOOLEAN ;
BEGIN
   IF (CharNo<High) AND (ch=CurrentSymbol[CharNo])
   THEN
      INC( CharNo ) ;
      RETURN( TRUE )
   ELSE
      RETURN( FALSE )
   END
END CharIs ;


(* IsChar - tests for current character = ch *)
(*          no side effects upon CharNo.     *)

PROCEDURE IsChar (ch: CHAR) : BOOLEAN ;
BEGIN
   RETURN (CharNo<High) AND (CurrentSymbol[CharNo]=ch)
END IsChar ;


(* Built in predicate for Character *)

PROCEDURE Character () : BOOLEAN ;
BEGIN
   IF CharNo<High
   THEN
      INC(CharNo) ;
      RETURN( TRUE )
   ELSE
      RETURN( FALSE )
   END
END Character ;


(* Built in predicate for Letter *)

PROCEDURE Letter () : BOOLEAN ;
BEGIN
   IF (CharNo<High) AND
      (((CurrentSymbol[CharNo]>='a') AND (CurrentSymbol[CharNo]<='z')) OR
       ((CurrentSymbol[CharNo]>='A') AND (CurrentSymbol[CharNo]<='Z')))
   THEN
      INC(CharNo) ;
      RETURN( TRUE )
   ELSE
      RETURN( FALSE )
   END
END Letter ;


PROCEDURE Digit () : BOOLEAN ;
BEGIN
   IF (CharNo<High) AND
      ((CurrentSymbol[CharNo]>='0') AND (CurrentSymbol[CharNo]<='9'))
   THEN
      INC(CharNo) ;
      RETURN( TRUE )
   ELSE
      RETURN( FALSE )
   END
END Digit ;


PROCEDURE SymIs (a: ARRAY OF CHAR) : BOOLEAN ;
BEGIN
   IF StrEqual(a, CurrentSymbol)
   THEN
      GetNextSymbol ;
      RETURN( TRUE )
   ELSE
      RETURN( FALSE )
   END
END SymIs ;


PROCEDURE IsSym (a: ARRAY OF CHAR) : BOOLEAN ;
BEGIN
   RETURN( StrEqual(a, CurrentSymbol) )
END IsSym ;


PROCEDURE Ident() : BOOLEAN ;
VAR
   Success: BOOLEAN ;
BEGIN
   InitChar ;
   IF Letter()
   THEN
      REPEAT
         IF Letter()
         THEN
            Success := TRUE
         ELSIF Digit()
         THEN
            Success := TRUE
         ELSE
            Success := FALSE
         END
      UNTIL NOT Success ;
      Success := TRUE ;
      GetNextSymbol
   ELSE
      Success := FALSE
   END ;
   RETURN( Success )
END Ident ;


PROCEDURE Main() : BOOLEAN ;
VAR
   Success: BOOLEAN ;
BEGIN
   IF ImportList()
   THEN
      Success := TRUE
   ELSE
      Success := FALSE
   END ;
   RETURN( Success )
END Main ;

PROCEDURE ImportList() : BOOLEAN ;
VAR
   Success: BOOLEAN ;
BEGIN
   IF SymIs('FROM')
   THEN
      IF Ident()
      THEN
         IF SymIs('IMPORT')
         THEN
            IF IdentList()
            THEN
               IF SymIs(';')
               THEN
                  Success := TRUE
               ELSE
                  Success := FALSE
               END
            ELSE
               Success := FALSE
            END
         ELSE
            Success := FALSE
         END
      ELSE
         Success := FALSE
      END
   ELSE
      Success := FALSE
   END ;
   RETURN( Success )
END ImportList ;

PROCEDURE IdentList() : BOOLEAN ;
VAR
   Success: BOOLEAN ;
BEGIN
   IF Ident()
   THEN
      WHILE SymIs(',') DO
         IF Ident()
         THEN
         END
      END ;
      Success := TRUE
   ELSE
      Success := FALSE
   END ;
   RETURN( Success )
END IdentList ;

PROCEDURE StartParsing ;
VAR
   Name: ARRAY [0..20] OF CHAR ;
BEGIN
   IF GetArg(Name, 1)
   THEN
      OpenSource(Name) ;
      IF NOT Main()
      THEN
         WriteError('Parser Failed')
      END ;
      CloseSourceFile
   END
END StartParsing ;


BEGIN
   StartParsing
END impexp.
