/* Header for module Lists, generated by p2c */
#ifndef ListsH
#define ListsH


/*
   Author     : Gaius Mulley
   Title      : Lists
   Date       : Tue Dec 12 20:53:36 EST 1989
   SYSTEM     : UNIX SUN and Logitech M2
   Description: Provides an unordered list manipulation package.
   Last update: $Date: 1997/03/12 15:49:25 $
   Version    : $Revision: 1.2 $
*/

/*
   Log        : $Log: Lists.h,v $
   Log        : Revision 1.2  1997/03/12 15:49:25  gaius
   Log        : finally clearing up the last? bugs in M2GenDyn486. Compiler now compiles
   Log        : itself with the new code generator, minor inefficiencies remain.
   Log        : Hopefully will work fix this soon. Swaping variables caused a problem,
   Log        : which has been fixed.
   Log        :
   Log        : Revision 1.1.1.1  1996/05/28 10:13:05  gaius
   Log        : Modula-2 compiler sources imported
   Log        :
*/

#ifndef SymbolKeyH
#include "SymbolKey.h"
#endif


#ifdef ListsG
# define vextern
#else
# define vextern extern
#endif




/*
   InitList - creates a new list, l.
*/


extern void Lists_InitList(void **l);


/*
   KillList - deletes the complete list, l.
*/

extern void Lists_KillList(void **l);


/*
   PutItemIntoList - places a CARDINAL, c, into list, l.
*/

extern void Lists_PutItemIntoList(void *l, unsigned long c);


/*
   GetItemFromList - retrieves the nth CARDINAL from list, l.
*/

extern unsigned long Lists_GetItemFromList(void *l, unsigned long n);


/*
   GetIndexOfList - returns the index for CARDINAL, c, in list, l.
                    If more than one CARDINAL, c, exists the index
                    for the first is returned.
*/

extern unsigned long Lists_GetIndexOfList(void *l, unsigned long c);


/*
   NoOfItemsInList - returns the number of items in list, l.
*/

extern unsigned long Lists_NoOfItemsInList(void *l);


/*
   IncludeItemIntoList - adds a CARDINAL, c, into a list providing
                         the value does not already exist.
*/

extern void Lists_IncludeItemIntoList(void *l, unsigned long c);


/*
   IsItemInList - returns true if a CARDINAL, c, was found in list, l.
*/

extern P2C_BOOLEAN Lists_IsItemInList(void *l, unsigned long c);


/*
   ForeachItemInListDo - calls procedure, P, foreach item in list, l.
*/

extern void Lists_ForeachItemInListDo(void *l, void (*P)(unsigned long));


/*
   DuplicateList - returns a duplicate list derived from, l.
*/

extern void *DuplicateList (void *) ;

#undef vextern

#endif /*ListsH*/

/* End. */
