IMPLEMENTATION MODULE FifoQueue ;


FROM StrIO IMPORT WriteString, WriteLn ;

CONST
   MaxQueueSize = 100 ;    (* FIFO queue size *)

VAR
   Queue       : ARRAY [0..MaxQueueSize] OF CARDINAL ;
   NoOfElements,
   In, Out     : CARDINAL ;


(*
   PutIntoFifoQueue - places a CARDINAL number, c, into a fifo queue.
*)

PROCEDURE PutIntoFifoQueue (c: CARDINAL) ;
BEGIN
   IF NoOfElements<MaxQueueSize
   THEN
      Queue[In] := c ;
      In := (In+1) MOD MaxQueueSize ;
      INC(NoOfElements)
   ELSE
      WriteString('Fifo queue is full, increase MaxQueueSize in FifoQueue') ;
      WriteLn ;
      HALT
   END
END PutIntoFifoQueue ;


(*
   GetFromFifoQueue - retrieves a CARDINAL number, c, from a fifo queue.
*)

PROCEDURE GetFromFifoQueue (VAR c: CARDINAL) ;
BEGIN
   IF NoOfElements>0
   THEN
      c := Queue[Out] ;
      Out := (Out+1) MOD MaxQueueSize ;
      DEC(NoOfElements)
   ELSE
      WriteString('Attempting to take an element from an empty Fifo queue in FifoQueue') ;
      WriteLn ;
      HALT
   END
END GetFromFifoQueue ;


(*
   InitFifoQueue - initializes the fifo queue.
                   This procedure is automatically called by the startup code
                   but it is included here so that users can reset the fifo queue.
*)

PROCEDURE InitFifoQueue ;
BEGIN
   In := 0 ;
   Out := 0 ;
   NoOfElements := 0
END InitFifoQueue ;


END FifoQueue.
