IMPLEMENTATION MODULE M2Error ;


FROM StdIO IMPORT PushOutput, PopOutput ;
IMPORT StdIO ;
IMPORT IO ;
FROM NumberIO IMPORT WriteCard ;
FROM StrLib IMPORT StrEqual, StrCopy ;
FROM StrIO IMPORT WriteString, WriteLn ;
FROM ASCII IMPORT lf ;


(* %%%FORWARD%%%
PROCEDURE Write (ch: CHAR) ; FORWARD ;
PROCEDURE Init ; FORWARD ;
   %%%FORWARD%%% *)


CONST
   MaxTitleSize  = 255 ;
   MaxBufferSize = 4096*4 ;

VAR
   LineOfError1,
   LineOfError2,
   ErrorIndex  : CARDINAL ;
   FileName1,
   FileName2,
   TitleHeader : ARRAY [0..MaxTitleSize] OF CHAR ;
   ErrorBuffer : ARRAY [0..MaxBufferSize] OF CHAR ;


(*
   Init - initializes the indices to the buffers.
*)

PROCEDURE Init ;
BEGIN
   ErrorIndex := 0 ;
   LineOfError1 := 0 ;
   LineOfError2 := 0
END Init ;

      
(*
   BeginError - switches the output channel to the error channel,
                all StdIO.Write calls will be redirected onto the error
                channel.
*)

PROCEDURE BeginError ;
BEGIN
   PushOutput(Write)
END BeginError ;


(*
   EndError - restores the output channel to the previous state before
              the last BeginError was called.
*)

PROCEDURE EndError ;
BEGIN
   PopOutput
END EndError ;


(*
   Title - title of the error.
*)

PROCEDURE Title (a: ARRAY OF CHAR;
                 File1, File2: ARRAY OF CHAR;
                 LineNo1, LineNo2: CARDINAL) ;
BEGIN
   StrCopy(a, TitleHeader) ;
   StrCopy(File1, FileName1) ;
   StrCopy(File2, FileName2) ;
   LineOfError1 := LineNo1 ;
   LineOfError2 := LineNo2
END Title ;


(*
   FlushError - flushes the error messages to stdout.
*)

PROCEDURE FlushError ;
VAR
   i: CARDINAL ;
   FileName: ARRAY [0..MaxTitleSize] OF CHAR ;
BEGIN
   PushOutput(IO.Write) ;
   IF NOT StrEqual('', TitleHeader)
   THEN
      WriteString(FileName1) ; StdIO.Write(':') ;
      WriteCard(LineOfError1, 0) ;
      StdIO.Write(':') ;
      WriteString(TitleHeader) ; WriteLn ;
      IF LineOfError2>1
      THEN
         WriteString(FileName2) ; StdIO.Write(':') ;
         WriteCard(LineOfError2, 0) ;
         StdIO.Write(':')
      END
   END ;
   i := 0 ;
   WHILE i<ErrorIndex DO
      StdIO.Write(ErrorBuffer[i]) ;
      INC(i)
   END ;
   Init ;
   PopOutput
END FlushError ;


(*
   Write - encapsulates characters which will form the error message.
*)

PROCEDURE Write (ch: CHAR) ;
BEGIN
   IF ErrorIndex<MaxBufferSize
   THEN
      ErrorBuffer[ErrorIndex] := ch ;
      INC(ErrorIndex)
   ELSE
      PushOutput(IO.Write) ;
      WriteString('increase MaxBufferSize in M2Error') ; WriteLn ;
      FlushError ;
      HALT
   END
END Write ;


BEGIN
   Init
END M2Error.
