IMPLEMENTATION MODULE M2FileName ;


FROM ASCII IMPORT nul ;
FROM StrLib IMPORT StrCopy, StrLen, StrConCat ;


CONST
   MaxFileName = 1024 ;                  (* For Unix           *)
   MaxStemName = MaxFileName - 3 - 1 ;   (* For Modula-2 stems *)


(*
   CalculateFileName - calculates the file name given a module and an
                       extension. This file name length will be operating
                       system specific.
*)

PROCEDURE CalculateFileName (Module, Extension: ARRAY OF CHAR;
                             VAR FileName: ARRAY OF CHAR) ;
VAR
   ExtLength: CARDINAL ;
   ModLength: CARDINAL ;
   i: INTEGER ;
BEGIN
   ExtLength := StrLen(Extension) ;
   StrCopy(Module, FileName) ;
   IF ExtLength=0
   THEN
      IF HIGH(FileName) > MaxFileName
      THEN
         FileName[MaxFileName-1] := nul
      END
   ELSE
      ModLength := StrLen(Module) ;
      (* The '.' separator uses one char of file name *)
      IF ModLength+1+ExtLength>MaxFileName
      THEN
         IF MaxFileName>1+ExtLength
         THEN
      	    i := MaxFileName-1-ExtLength ;
      	    FileName[i] := nul ;
            FileName[MaxFileName-1-ExtLength] := nul
      	    (* Truncate module name *)
         END
      END ;
      StrConCat(FileName, '.', FileName) ;
      StrConCat(FileName, Extension, FileName)
   END
END CalculateFileName ;


(*
   CalculateStemName - calculates the stem name for given a module.
                       This name length will be operating system and
      	       	       compiler specific.
*)

PROCEDURE CalculateStemName (Module: ARRAY OF CHAR;
                             VAR FileName: ARRAY OF CHAR) ;
BEGIN
   StrCopy(Module, FileName) ;
   IF HIGH(FileName) > MaxStemName
   THEN
      FileName[MaxStemName] := nul
   END
END CalculateStemName ;


END M2FileName.
