IMPLEMENTATION MODULE M2Pass ;


FROM M2Lexical IMPORT WriteError ;

TYPE
   Pass        = (NoPass, Pass1, Pass2, Pass3, CodeGeneration, ErrorPass) ;

VAR
   CurrentPass: Pass ;


(*
   SetPassToNoPass - sets the pass state to no Pass.
*)

PROCEDURE SetPassToNoPass ;
BEGIN
   CurrentPass := NoPass
END SetPassToNoPass ;


(*
   SetPassToPass1 - sets the pass state to Pass 1.
*)

PROCEDURE SetPassToPass1 ;
BEGIN
   IF CurrentPass=NoPass
   THEN
      CurrentPass := Pass1
   ELSE
      WriteError('attempting to set CurrentPass to Pass1')
   END
END SetPassToPass1 ;



(*
   SetPassToPass2 - sets the pass state to Pass 2.
*)

PROCEDURE SetPassToPass2 ;
BEGIN
   IF CurrentPass=NoPass
   THEN
      CurrentPass := Pass2
   ELSE
      WriteError('attempting to set CurrentPass to Pass2')
   END
END SetPassToPass2 ;



(*
   SetPassToPass3 - sets the pass state to Pass 3.
*)

PROCEDURE SetPassToPass3 ;
BEGIN
   IF CurrentPass=NoPass
   THEN
      CurrentPass := Pass3
   ELSE
      WriteError('attempting to set CurrentPass to Pass3')
   END
END SetPassToPass3 ;


(*
   SetPassToErrorPass - sets the pass state to no Error Pass.
*)

PROCEDURE SetPassToErrorPass ;
BEGIN
   CurrentPass := ErrorPass
END SetPassToErrorPass ;


(*
   SetPassToCodeGeneration - sets the pass state to CodeGeneration.
*)

PROCEDURE SetPassToCodeGeneration ;
BEGIN
   IF CurrentPass=NoPass
   THEN
      CurrentPass := CodeGeneration
   ELSE
      WriteError('attempting to set CurrentPass to CodeGeneration')
   END
END SetPassToCodeGeneration ;


(*
   IsNoPass - returns true if currently in no Pass.
*)

PROCEDURE IsNoPass () : BOOLEAN ;
BEGIN
   RETURN( CurrentPass=NoPass )
END IsNoPass ;


(*
   IsPass1 - returns true if currently in Pass 1.
*)

PROCEDURE IsPass1 () : BOOLEAN ;
BEGIN
   RETURN( CurrentPass=Pass1 )
END IsPass1 ;


(*
   IsPass2 - returns true if currently in Pass 2.
*)

PROCEDURE IsPass2 () : BOOLEAN ;
BEGIN
   RETURN( CurrentPass=Pass2 )
END IsPass2 ;


(*
   IsPass3 - returns true if currently in Pass 3.
*)

PROCEDURE IsPass3 () : BOOLEAN ;
BEGIN
   RETURN( CurrentPass=Pass3 )
END IsPass3 ;


(*
   IsPassCodeGeneration - returns true if currently in the CodeGeneration Pass.
*)

PROCEDURE IsPassCodeGeneration () : BOOLEAN ;
BEGIN
   RETURN( CurrentPass=CodeGeneration )
END IsPassCodeGeneration ;


(*
   IsErrorPass - returns true if currently in the Error Pass.
*)

PROCEDURE IsErrorPass () : BOOLEAN ;
BEGIN
   RETURN( CurrentPass=ErrorPass )
END IsErrorPass ;


BEGIN
   SetPassToNoPass
END M2Pass.
