IMPLEMENTATION MODULE M2Reserved ;


FROM SymbolKey IMPORT SymbolTree, InitTree, PutSymKey, GetSymKey ;
FROM NameKey IMPORT MakeKey ;
(*
FROM ASCII IMPORT eof, nul ;  (* UNIX *)
*)

FROM ASCII IMPORT nul ;  (* Logitech M-2 *)

CONST
   eof = 032C ;

VAR
   ReservedWords: SymbolTree ;


PROCEDURE Init ;
VAR
   a: ARRAY [0..1] OF CHAR ;
BEGIN
   InitTree(ReservedWords) ;

   NulTok := 0 ;

   PlusTok := MakeKey('+') ;
   PutSymKey(ReservedWords, PlusTok, 1) ;

   MinusTok := MakeKey('-') ;
   PutSymKey(ReservedWords, MinusTok, 1) ;

   TimesTok := MakeKey('*') ;
   PutSymKey(ReservedWords, TimesTok, 1) ;

   DivideTok := MakeKey('/') ;
   PutSymKey(ReservedWords, DivideTok, 1) ;

   BecomesTok := MakeKey(':=') ;
   PutSymKey(ReservedWords, BecomesTok, 1) ;

   AmbersandTok := MakeKey('&') ;
   PutSymKey(ReservedWords, AmbersandTok, 1) ;

   PeriodTok := MakeKey('.') ;
   PutSymKey(ReservedWords, PeriodTok, 1) ;

   CommaTok := MakeKey(',') ;
   PutSymKey(ReservedWords, CommaTok, 1) ;

   SemiColonTok := MakeKey(';') ;
   PutSymKey(ReservedWords, SemiColonTok, 1) ;

   LParaTok := MakeKey('(') ;
   PutSymKey(ReservedWords, LParaTok, 1) ;

   LSBraTok := MakeKey('[') ;
   PutSymKey(ReservedWords, LSBraTok, 1) ;

   LCBraTok := MakeKey('{') ;
   PutSymKey(ReservedWords, LCBraTok, 1) ;

   UpArrowTok := MakeKey('^') ;
   PutSymKey(ReservedWords, UpArrowTok, 1) ;

   SingleQuoteTok := MakeKey("'") ;
   PutSymKey(ReservedWords, SingleQuoteTok, 1) ;

   EqualTok := MakeKey('=') ;
   PutSymKey(ReservedWords, EqualTok, 1) ;

   HashTok := MakeKey('#') ;
   PutSymKey(ReservedWords, HashTok, 1) ;

   LessTok := MakeKey('<') ;
   PutSymKey(ReservedWords, LessTok, 1) ;

   GreaterTok := MakeKey('>') ;
   PutSymKey(ReservedWords, GreaterTok, 1) ;

   LessGreaterTok := MakeKey('<>') ;
   PutSymKey(ReservedWords, LessGreaterTok, 1) ;

   LessEqualTok := MakeKey('<=') ;
   PutSymKey(ReservedWords, LessEqualTok, 1) ;

   GreaterEqualTok := MakeKey('>=') ;
   PutSymKey(ReservedWords, GreaterEqualTok, 1) ;

   PeriodPeriodTok := MakeKey('..') ;
   PutSymKey(ReservedWords, PeriodPeriodTok, 1) ;

   ColonTok := MakeKey(':') ;
   PutSymKey(ReservedWords, ColonTok, 1) ;

   RParaTok := MakeKey(')') ;
   PutSymKey(ReservedWords, RParaTok, 1) ;

   RSBraTok := MakeKey(']') ;
   PutSymKey(ReservedWords, RSBraTok, 1) ;

   RCBraTok := MakeKey('}') ;
   PutSymKey(ReservedWords, RCBraTok, 1) ;

   BarTok := MakeKey('|') ;
   PutSymKey(ReservedWords, BarTok, 1) ;

   DoubleQuotesTok := MakeKey('"') ;
   PutSymKey(ReservedWords, DoubleQuotesTok, 1) ;


   AndTok := MakeKey('AND') ;
   PutSymKey(ReservedWords, AndTok, 1) ;

   ArrayTok := MakeKey('ARRAY') ;
   PutSymKey(ReservedWords, ArrayTok, 1) ;

   BeginTok := MakeKey('BEGIN') ;
   PutSymKey(ReservedWords, BeginTok, 1) ;

   ByTok := MakeKey('BY') ;
   PutSymKey(ReservedWords, ByTok, 1) ;

   CaseTok := MakeKey('CASE') ;
   PutSymKey(ReservedWords, CaseTok, 1) ;

   ConstTok := MakeKey('CONST') ;
   PutSymKey(ReservedWords, ConstTok, 1) ;

   DefinitionTok := MakeKey('DEFINITION') ;
   PutSymKey(ReservedWords, DefinitionTok, 1) ;

   DivTok := MakeKey('DIV') ;
   PutSymKey(ReservedWords, DivTok, 1) ;

   DoTok := MakeKey('DO') ;
   PutSymKey(ReservedWords, DoTok, 1) ;

   ElseTok := MakeKey('ELSE') ;
   PutSymKey(ReservedWords, ElseTok, 1) ;

   ElsifTok := MakeKey('ELSIF') ;
   PutSymKey(ReservedWords, ElsifTok, 1) ;

   EndTok := MakeKey('END') ;
   PutSymKey(ReservedWords, EndTok, 1) ;

   ExitTok := MakeKey('EXIT') ;
   PutSymKey(ReservedWords, ExitTok, 1) ;

   ExportTok := MakeKey('EXPORT') ;
   PutSymKey(ReservedWords, ExportTok, 1) ;

   ForTok := MakeKey('FOR') ;
   PutSymKey(ReservedWords, ForTok, 1) ;

   FromTok := MakeKey('FROM') ;
   PutSymKey(ReservedWords, FromTok, 1) ;

   IfTok := MakeKey('IF') ;
   PutSymKey(ReservedWords, IfTok, 1) ;

   ImplementationTok := MakeKey('IMPLEMENTATION') ;
   PutSymKey(ReservedWords, ImplementationTok, 1) ;

   ImportTok := MakeKey('IMPORT') ;
   PutSymKey(ReservedWords, ImportTok, 1) ;

   InTok := MakeKey('IN') ;
   PutSymKey(ReservedWords, InTok, 1) ;

   LoopTok := MakeKey('LOOP') ;
   PutSymKey(ReservedWords, LoopTok, 1) ;

   ModTok := MakeKey('MOD') ;
   PutSymKey(ReservedWords, ModTok, 1) ;

   ModuleTok := MakeKey('MODULE') ;
   PutSymKey(ReservedWords, ModuleTok, 1) ;

   NotTok := MakeKey('NOT') ;
   PutSymKey(ReservedWords, NotTok, 1) ;

   OfTok := MakeKey('OF') ;
   PutSymKey(ReservedWords, OfTok, 1) ;

   OrTok := MakeKey('OR') ;
   PutSymKey(ReservedWords, OrTok, 1) ;

   PointerTok := MakeKey('POINTER') ;
   PutSymKey(ReservedWords, PointerTok, 1) ;

   ProcedureTok := MakeKey('PROCEDURE') ;
   PutSymKey(ReservedWords, ProcedureTok, 1) ;

   QualifiedTok := MakeKey('QUALIFIED') ;
   PutSymKey(ReservedWords, QualifiedTok, 1) ;

   UnQualifiedTok := MakeKey('UNQUALIFIED') ;
   PutSymKey(ReservedWords, UnQualifiedTok, 1) ;

   RecordTok := MakeKey('RECORD') ;
   PutSymKey(ReservedWords, RecordTok, 1) ;

   RepeatTok := MakeKey('REPEAT') ;
   PutSymKey(ReservedWords, RepeatTok, 1) ;

   ReturnTok := MakeKey('RETURN') ;
   PutSymKey(ReservedWords, ReturnTok, 1) ;

   SetTok := MakeKey('SET') ;
   PutSymKey(ReservedWords, SetTok, 1) ;

   ThenTok := MakeKey('THEN') ;
   PutSymKey(ReservedWords, ThenTok, 1) ;

   ToTok := MakeKey('TO') ;
   PutSymKey(ReservedWords, ToTok, 1) ;

   TypeTok := MakeKey('TYPE') ;
   PutSymKey(ReservedWords, TypeTok, 1) ;

   UntilTok := MakeKey('UNTIL') ;
   PutSymKey(ReservedWords, UntilTok, 1) ;

   VarTok := MakeKey('VAR') ;
   PutSymKey(ReservedWords, VarTok, 1) ;

   WhileTok := MakeKey('WHILE') ;
   PutSymKey(ReservedWords, WhileTok, 1) ;

   WithTok := MakeKey('WITH') ;
   PutSymKey(ReservedWords, WithTok, 1) ;

   AsmTok := MakeKey('ASM') ;
   PutSymKey(ReservedWords, AsmTok, 1) ;

   DateTok := MakeKey('__DATE__') ;     (* C compatible preprocessor prims *)
   PutSymKey(ReservedWords, DateTok, 1) ;

   LineTok := MakeKey('__LINE__') ;
   PutSymKey(ReservedWords, LineTok, 1) ;

   FileTok := MakeKey('__FILE__') ;
   PutSymKey(ReservedWords, FileTok, 1) ;

   a[0] := eof ;
   a[1] := nul ;
   EofTok := MakeKey(a)              (* Not a reserved token *)
END Init ;


PROCEDURE IsReserved (Name: CARDINAL) : BOOLEAN ;
BEGIN
   RETURN (GetSymKey(ReservedWords, Name)#0)
END IsReserved ;


BEGIN
   Init
END M2Reserved.
