IMPLEMENTATION MODULE Methods ;


FROM SYSTEM IMPORT ADDRESS, ADR ;
FROM Storage IMPORT ALLOCATE ;


CONST
   MaxParameters = 6 ;

TYPE
   Method = POINTER TO RECORD
                          NoOfParameters: CARDINAL ;
                          Procedure     : ADDRESS ;
                          Parameters    : ARRAY [1..MaxParameters] OF WORD ;
                       END ;


(*
   Apply - apply Method, m.
*)

PROCEDURE Apply (m: Method) ;
VAR
   p0: PROC ;
   p1: ProcedureVal ;  (* use this for Ref as well *)
BEGIN
   WITH m^ DO
      CASE NoOfParameters OF

      0: p0 := PROC(Procedure)         ; p0 |
      1: p1 := ProcedureVal(Procedure) ; p1(Parameters[1])

      END
   END
END Apply ;


(*
   MakeMethod - make a parameter less method.
*)

PROCEDURE MakeMethod (p: PROC) : Method ;
VAR
   m: Method ;
BEGIN
   NEW(m) ;
   WITH m^ DO
      NoOfParameters := 0 ;
      Procedure := ADDRESS(p) ;
   END ;
   RETURN( m )
END MakeMethod ;


(*
   MakeMethodVal - make a method with one Value parameter.
*)

PROCEDURE MakeMethodVal (p: ProcedureVal; Val: WORD) : Method ;
VAR
   m: Method ;
BEGIN
   NEW(m) ;
   WITH m^ DO
      NoOfParameters := 1 ;
      Procedure := ADDRESS(p) ;
      Parameters[1] := Val ;
   END ;
   RETURN( m )
END MakeMethodVal ;


(*
   MakeMethodRef - make a method with one Reference parameter.
*)

PROCEDURE MakeMethodRef (p: ProcedureRef; VAR Ref: WORD) : Method ;
VAR
   m: Method ;
BEGIN
   NEW(m) ;
   WITH m^ DO
      NoOfParameters := 1 ;
      Procedure := ADDRESS(p) ;
      Parameters[1] := ADR(Ref) ;
   END ;
   RETURN( m )
END MakeMethodRef ;


END Methods.
