IMPLEMENTATION MODULE YacTok ;


FROM NameKey IMPORT NulName, WriteKey ;
FROM StrIO IMPORT WriteString, WriteLn ;
FROM NumberIO IMPORT WriteCard ;


CONST
   MaxTokens = 1000 ;

VAR
   TokenStream: ARRAY [0..MaxTokens] OF CARDINAL ;
   TokenTop   : CARDINAL ;


(*
   InitTok - initializes the token stream to empty.
*)

PROCEDURE InitTok ;
BEGIN
   IF TokenTop>0
   THEN
      TokenStream[0] := TokenStream[TokenTop-1] ;
      TokenTop := 1
   END
END InitTok ;


(*
   GetTok - returns the, i, token from the token stream.
            NulTok is returned if, i, is not available.
            Tokens are ordered (FIFO) 0..n.
*)

PROCEDURE GetTok (i: CARDINAL) : CARDINAL ;
BEGIN
   IF i<TokenTop
   THEN
      RETURN( TokenStream[i] )
   ELSE
      RETURN( NulName )      
   END
END GetTok ;


(*
   PutTok - places a token, t, into the input stream.
*)

PROCEDURE PutTok (t: CARDINAL) ;
BEGIN
   IF TokenTop=MaxTokens
   THEN
      WriteString('TokenTop exceeded MaxTokens - increase MaxTokens in YacTok.mod') ; WriteLn
   ELSE
(*
      WriteString('Token #') ; WriteCard(TokenTop, 4) ;
      WriteCard(TokenTop, 4) ; WriteString(' = ') ; WriteKey(t) ; WriteLn ;
*)
      TokenStream[TokenTop] := t ;
      INC(TokenTop)
   END
END PutTok ;


BEGIN
   TokenTop := 0
END YacTok.
