MODULE asm2src ;
 
(*
   Author     : Gaius Mulley
   Title      : asm2src
   Date       : Wed May 23 16:25:02 BST 1990
   SYSTEM     : UNIX SUN and Logitech M2
   Last update: Wed May 23 16:25:10 BST 1990
   Description: Produces an asm listing together with comment .mod source.
*)
 
FROM ASCII IMPORT cr, ;
FROM StrLib IMPORT StrEqual, StrCopy, StrConCat ;
FROM NumberIO IMPORT StrToCard ;
FROM StrIO IMPORT WriteString, WriteLn ;
FROM FileSystem IMPORT File, Lookup, File, Close, Response ;
FROM Args IMPORT Narg, GetArg ;

 
CONST
   MaxStringLen =  255 ;
 

VAR
   AsmLine   : ARRAY [0..MaxStringLen] OF CHAR ;
   Module    : ARRAY [0..MaxStringLen] OF CHAR ;
   SourceLine: CARDINAL ;
   SinglePage: BOOLEAN ;
   M2File,
   AsmFile   : File ;


(*
   ProcessFiles -
*)

PROCEDURE ProcessFiles ;
VAR
   a: ARRAY [0..MaxStringLen] OF CHAR ;
BEGIN
   SourceLine := 0 ;
   StrConCat(Module, '.mod', a) ;
   Lookup(a, M2File, FALSE) ;
   StrConCat(Module, '.s', a) ;
   Lookup(a, AsmFile, FALSE) ;
   WHILE NOT Eof(AsmFile) DO
      ConsumeAsmLine
   END ;
   FlushPage ;
   Close(M2File) ;
   Close(AsmFile)
END ProcessFiles ;


(*
   ConsumeAsmLine
*)

PROCEDURE ConsumeAsmLine ;
VAR
   Name: ARRAY [0..5] OF CHAR ;
BEGIN
   ReadAsmLine(AsmLine) ;
   StrCopy(AsmLine, Name) ;
   IF StrEqual(Name, '; Line')
   THEN

   END
END ConsumeAsmLine ;


PROCEDURE ReadAsmLine (VAR a: ARAY OF CHAR) ;
VAR
   ch: CHAR ;
   i : CARDINAL ;
BEGIN
   i := 0 ;
   ReadChar(AsmFile, ch) ;
   WHILE (ch#lf) AND (i<HIGH(a)) DO
      a[i] := ch ;
      INC(i) ;
      ReadChar(AsmFile, ch)
   END ;
   IF i<HIGH(a)
   THEN
      a[i] := nul
   END
END ReadAsmLine ;



(*
   Exists - returns true if a file, a, with extension ex exists.
*)

PROCEDURE Exists (a, ex: ARRAY OF CHAR) : BOOLEAN ;
VAR
   f: File ;
   b: ARRAY [0..MaxStringLen] OF CHAR ;
   found: BOOLEAN ;
   i    : CARDINAL ;
BEGIN
   StrConCat( a, ex, b ) ;
   Lookup( f, b, FALSE ) ;
   IF f.res=done
   THEN
      found := TRUE
   ELSE
      found := FALSE
   END ;
   Close( f ) ;
   RETURN( found )
END Exists ;


BEGIN
   IF GetArg( a, 1 )
   THEN
      IF NOT Exists(a, '.mod')
      THEN
         WriteString(a) ; WriteString('.mod') ; WriteString(' --- NOT found') ;
         WriteLn
      ELSIF NOT Exists(a, '.s')
      THEN
         WriteString(a) ; WriteString('.s') ; WriteString(' --- NOT found') ;
         WriteLn
      ELSE
         StrCopy(a, Module) ;
         SinglePage := GetArg(a, 2) AND StrEqual(a, '-s') ;
         ProcessFiles
      END
   ELSE
      WriteString('Usage: asm2src modulename [-s]') ; WriteLn
   END
END asm2src.
