MODULE gm2lccc ;

(*
   Author     : Gaius Mulley
   Title      : gm2lccc
   Date       : Thu Jun  7 16:23:32 BST 1990
   Description: Generates the cc -c file.s commands,
                from a list of module names.
   Last update: Thu Jun  7 16:23:38 BST 1990
*)

FROM StrLib IMPORT StrEqual ;

FROM StrIO IMPORT ReadString, WriteString, WriteLn ;

FROM ASCII IMPORT eof ;  (* UNIX *)


CONST
   MaxName = 255  ; (* Length of an identifier *)
(*
   eof     =  32C ; (* Dos                     *)
*)
   Comment = '#'  ; (* Comment identifier.     *)

(*
   GenCC - writes out the linkage command for the C compiler.
*)

PROCEDURE GenCCC ;
VAR
   a: ARRAY [0..MaxName] OF CHAR ;
BEGIN
   WriteString('gcc -c -g main.c') ; WriteLn ;
   ReadString(a) ;
   WHILE a[0]#eof DO
      IF (a[0]#Comment) AND (NOT StrEqual(a, ''))
      THEN
         WriteString('gcc -c -g ') ; WriteString(a) ; WriteString('.s') ; WriteLn ;
      END ;
      ReadString(a)
   END ;
   WriteLn
END GenCCC ;


BEGIN
   GenCCC
END gm2lccc.
