MODULE gm2lsub ;

(*
   Author     : Gaius Mulley
   Title      : gm2lsub
   Date       : Thu Jun  7 16:33:14 BST 1990
   Description: Ensures than M2RTS is initialized before all other
                modules.
   Last update: Thu Jun  7 16:33:20 BST 1990
*)


FROM StrLib IMPORT StrEqual ;
FROM StrIO IMPORT ReadString, WriteString, WriteLn ;
FROM ASCII IMPORT eof ;  (* UNIX *)


CONST
   MaxName = 255  ; (* Length of an identifier *)
(*
   eof     =  32C ; (* Dos                     *)
*)
   Comment = '#'  ; (* Comment identifier.     *)


PROCEDURE IsPseudoModule (a: ARRAY OF CHAR) : BOOLEAN ;
BEGIN
   RETURN( StrEqual(a, 'libc') )
END IsPseudoModule ;


(*
   IsM2RTS - returns true if the module is M2RTS.
*)

PROCEDURE IsM2RTS (a: ARRAY OF CHAR) : BOOLEAN ;
BEGIN
   RETURN( StrEqual(a, 'M2RTS') )
END IsM2RTS ;


(*
   GenSub - writes out the modules which require compiling and linking.
*)

PROCEDURE GenSub ;
VAR
   a: ARRAY [0..MaxName] OF CHAR ;
BEGIN
   WriteString('M2RTS') ; WriteLn ;
   ReadString(a) ;
   WHILE a[0]#eof DO
      IF (a[0]#Comment) AND (NOT IsM2RTS(a))
      THEN
         WriteString(a) ; WriteLn ;
      END ;
      ReadString(a)
   END ;
   WriteLn
END GenSub ;


BEGIN
   GenSub
END gm2lsub.
