MODULE p2lgen ;

(*
   Author     : Gaius Mulley
   Title      : p2lgen
   Date       : Mon Apr 15 23:37:19 gmt 1991
   Description: Generates the C main.c code, from a list of module names.
   Last update: Mon Apr 15 23:37:24 gmt 1991
*)

FROM StrLib IMPORT StrEqual ;

FROM StrIO IMPORT ReadString, WriteString, WriteLn ;

FROM ASCII IMPORT eof ;  (* UNIX *)


CONST
   MaxName = 255  ; (* Length of an identifier *)
(*
   eof     =  32C ; (* Dos                     *)
*)
   Comment = '#'  ; (* Comment identifier      *)

PROCEDURE GenMain ; FORWARD ;
PROCEDURE GenInitializationCalls ; FORWARD ;


(*
   GenMain - writes out the main() function together with module initialization
             calls.
*)

PROCEDURE GenMain ;
VAR
   a: ARRAY [0..MaxName] OF CHAR ;
BEGIN
   WriteString('modula_startup(argc, argv)') ; WriteLn ;
   WriteString('int   argc ;') ; WriteLn ;
   WriteString('char  *argv[];') ; WriteLn ;
   WriteString('{') ; WriteLn ;
   GenInitializationCalls ;
   WriteString('}') ; WriteLn
END GenMain ;


(*
   GenInitializationCalls - writes out the initialization calls for the modules
                            in the application suit.
*)

PROCEDURE GenInitializationCalls ;
VAR
   a: ARRAY [0..MaxName] OF CHAR ;
BEGIN
   ReadString(a) ;
   WHILE a[0]#eof DO
      IF (a[0]#Comment) AND (NOT StrEqual(a, ''))
      THEN
         WriteString('   _') ; WriteString(a) ; WriteString('_init(argc, argv) ;') ; WriteLn ;
      END ;
      ReadString(a)
   END
END GenInitializationCalls ;


BEGIN
   GenMain
END p2lgen.
