MODULE t ;

FROM ASCII IMPORT nul ;
FROM StrLib IMPORT StrLen ;
FROM NameKey IMPORT GetKey ;
FROM NumberIO IMPORT StrToInt, StrToCard, StrToHex, StrToOct, StrToBin, WriteCard, BinToStr, StrToBinInt ;
FROM FpuIO IMPORT StrToLongReal ;
FROM M2Lexical IMPORT WriteError, InternalError ;
FROM StrIO IMPORT WriteString, WriteLn ;
FROM M2Debug IMPORT Assert ;
FROM M2System IMPORT BitsetSize ;
FROM SYSTEM IMPORT BITSET, BYTE, ADR ;

CONST
   MaxStack      =  100 ;
   MaxBitsetSize =    4 ;  (* Max number of bytes for a bitset *)

TYPE
   PtrToValue = [1..100] ;
   TypeOfSign = (Negative, Positive) ;
   TypeOfValue= (Integer, Real) ;

   Mem  = RECORD
             Sign : TypeOfSign ;
             Type : TypeOfValue ;
             Value: LONGINT ;
             Float: LONGREAL ;
          END ;

   Cell = RECORD
             Content: Mem ;
             Solved : BOOLEAN ;
          END ;

VAR
   Stack    : ARRAY [0..MaxStack] OF Mem ;
   Cells    : ARRAY PtrToValue OF Cell ;
   CellsUsed: CARDINAL ;
   Ptr      : CARDINAL ;


(*
   PopMem - pops the top element from the stack into v.
*)

PROCEDURE PopMem (VAR v: Mem) ;
BEGIN
   IF Ptr=0
   THEN
      InternalError('Stack Underflow', __FILE__, __LINE__)
   ELSE
      DEC(Ptr) ;
      v := Stack[Ptr]
   END
END PopMem ;

VAR
   v: Mem ;
BEGIN
   PopMem(v)
END t.
