MODULE testtype ;


FROM Storage IMPORT ALLOCATE, DEALLOCATE ;

TYPE
   SymbolTree = POINTER TO Node ;
   Node       = RECORD
                   KeyName : CARDINAL ;   (* The sorted entity *)
                   KeySym  : CARDINAL ;   (* The value entity  *)
                   Left    : SymbolTree ;
                   Right   : SymbolTree ;
                END ;


(*
  Logitech compiler compilains about this procedure:


  But the compiler gives type incompatibilities under the parameters
  for:
       KillTree(t^.Left)
       KillTree(t^.Right)

*)


PROCEDURE KillTree (VAR t: SymbolTree) ;
BEGIN
   IF t#NIL
   THEN
      KillTree(t^.Left) ;
      KillTree(t^.Right) ;
      DISPOSE(t) ;
      t := NIL
   END
END KillTree ;


VAR
   t: SymbolTree ;
BEGIN
   NEW(t) ;
   WITH t^ DO
      Left := NIL ;
      Right := NIL ;
   END ;
   KillTree(t)
END testtype.
