MODULE varient3 ;

TYPE
   List = CARDINAL ;
   PtrToValue = CARDINAL ;
   TypeOfSymbol
              = (RecordSym, VarientSym,
                 VarSym, EnumerationSym, SubrangeSym, ArraySym,
                 ConstStringSym, ConstVarSym, ConstLitSym,
                 VarParamSym, ParamSym, PointerSym,
                 UndefinedSym, TypeSym,
                 RecordFieldSym, VarientFieldSym, EnumerationFieldSym,
                 DefImpSym, ModuleSym, SetSym, ProcedureSym, ProcTypeSym,
                 DummySym, SubscriptSym, UnboundedSym) ;


   SymUndefined = RECORD
                     Name      : CARDINAL ;   (* Index into name array, name *)
                                              (* of record.                  *)
                  END ;

   SymVarient = RECORD
                   Size        : PtrToValue ; (* Size at runtime of symbol.  *)
                   ListOfSons  : List ;       (* ListOfSons contains a list  *)
                                              (* of SymRecordField and       *)
                                              (* SymVarients                 *)
                                              (* declared by the source      *)
                                              (* file.                       *)
                   Parent      : CARDINAL ;   (* Points to the Father Symbol *)
               END ;

   Symbol = RECORD
               CASE SymbolType : TypeOfSymbol OF
                                            (* Determines the type of symbol *)

               UndefinedSym        : Undefined        : SymUndefined |
               VarientSym          : Varient          : SymVarient

      	       END
      	    END ;

CONST
   MaxSymbols = 10 ;

VAR
   c: CARDINAL ;
   Symbols: ARRAY [0..MaxSymbols] OF Symbol ;
BEGIN
   FOR c := 1 TO MaxSymbols DO
      Symbols[c].SymbolType := VarientSym
   END
END varient3.
