MODULE with ;


FROM StrIO IMPORT WriteString, WriteLn ;
FROM Storage IMPORT ALLOCATE, DEALLOCATE ;


CONST
   MaxNoOfElements = 5 ;

TYPE
   List = POINTER TO list ;
   list = RECORD
             NoOfElements: CARDINAL ;
             Elements    : ARRAY [0..MaxNoOfElements-1] OF CARDINAL ;
             Next        : List ;
          END ;

(*
   InitList - creates a new list, l.
*)

PROCEDURE InitList (VAR l: List) ;
BEGIN
   NEW(l) ;
   WITH l^ DO
      NoOfElements := 0 ;
      Next := NIL
   END
END InitList ;


(*
   NoOfItemsInList - returns the number of items in list, l.
                     (iterative algorithm of the above).
*)

PROCEDURE NoOfItemsInList (l: List) : CARDINAL ;
VAR
   t: CARDINAL ;
BEGIN
   IF l=NIL
   THEN
      RETURN( 0 )
   ELSE
      t := 0 ;
      REPEAT
         WITH l^ DO
            t := t+NoOfElements ;
            IF t=0
            THEN
            END ;
            INC(NoOfElements, t) ;
            INC(t, NoOfElements)
         END ;
         l := l^.Next
      UNTIL l=NIL;
      RETURN( t )
   END
END NoOfItemsInList ;


(*
   TestIt - 
*)

PROCEDURE TestIt ;
VAR
   l: List ;
BEGIN
   InitList(l) ;
   IF NoOfItemsInList(l)=0
   THEN
      WriteString('passed') ; WriteLn
   ELSE
      WriteString('failed') ; WriteLn
   END
END TestIt ;
   
   
BEGIN
   TestIt
END with.
