/* Output from p2c, the Pascal-to-C translator */
/* From input file "MemUtils.md" */


#include <p2c/p2c.h>


#define MemUtilsG
#include "MemUtils.h"


/*
   MemCopy - copys a region of memory to the required destination.
*/

void MemUtils_MemCopy(void *from, unsigned long length, void *to)
{
  long *pwb, *pwa;
  uchar *pbb, *pba;

  while (length >= sizeof(long)) {
    pwa = (long *)from;
    pwb = (long *)to;
    *pwb = *pwa;
    from += sizeof(long);
    to += sizeof(long);
    length -= sizeof(long);
  }
  while (length > 0) {
    pba = (uchar *)from;
    pbb = (uchar *)to;
    *pbb = *pba;
    from += sizeof(uchar);
    to += sizeof(uchar);
    length -= sizeof(uchar);
  }
}


/*
   MemZero - sets a region of memory: a..a+length to zero.
*/

void Memutils_MemZero (void *a, unsigned long length)
{
  long *pwa;
  uchar *pba;

  pwa = (long*)a ;
  while (length >= sizeof(long)) {
    *pwa = 0;
    pwa++;
    length -= sizeof(long);
  }
  pba = (uchar *)pwa;
  while (length >= sizeof(uchar)) {
    *pba = 0;
    pba++;
    length--;
  }
}


void _M2_MemUtils_init(void)
{
}
/* p2c: Note: Remember to call _M2_MemUtils_init() in main program [215] */



/* End. */
