/* Header for module StdIO, generated by p2c */
#ifndef StdIOH
#define StdIOH


#ifdef StdIOG
# define vextern
#else
# define vextern extern
#endif


/*
   Author     : Gaius Mulley
   Title      : StdIO
   Date       : 12/2/86  [$Date: 1996/05/28 10:13:07 $]
   SYSTEM     : UNIX SUN and Logitech M2
   Description: Exports a general Read and Write procedure that ALL character
                processes should use.
   Version    : $Revision: 1.1.1.1 $
*/

/*
   Log        : $Log: StdIO.h,v $
   Log        : Revision 1.1.1.1  1996/05/28 10:13:07  gaius
   Log        : Modula-2 compiler sources imported
   Log        :
*/





/*
   Read - is the generic procedure that all higher application layers
          should use to receive a character.
*/


extern Void StdIO_Read PP((Char *ch));


/*
   Write - is the generic procedure that all higher application layers
           should use to emit a character.
*/

extern Void StdIO_Write PP((int ch));


/*
   PushOutput - pushes the current Write procedure onto a stack,
                any future references to Write will actually invoke
                procedure, p.
*/

extern Void StdIO_PushOutput PP((Void (*p) PP((Char))));


/*
   PopOutput - restores Write to use the previous output procedure.
*/

extern Void StdIO_PopOutput PV();


/*
   GetCurrentOutput - returns the current output procedure.
*/

extern void *StdIO_GetCurrentOutput (void);

#undef vextern

#endif /*StdIOH*/

/* End. */
