IMPLEMENTATION MODULE Sort;

(* defined in the .def file *)
(*   LessProcType = PROCEDURE(CARDINAL,CARDINAL) : BOOLEAN;   *)
(*   SwapProcType = PROCEDURE(CARDINAL,CARDINAL);             *)

PROCEDURE BubbleSort(no: CARDINAL; Less: LessProcType; Swap: SwapProcType) ;
VAR
   next_rec, record_no: CARDINAL;
BEGIN
   next_rec := 0;
   (* While there is a next rec, check each rec for correct sequence *)
   WHILE next_rec # no DO
      (* get next*)
      INC(next_rec);
      FOR record_no := next_rec TO no DO
         (*is the current record more than the next *)
         IF NOT Less(next_rec,record_no)
         THEN
            Swap(next_rec,record_no);
         END (*if*)
      END (*for*)
   END (*while*)
END BubbleSort ;


PROCEDURE QuickSort (no: CARDINAL; Less: LessProcType; Swap: SwapProcType) ;
VAR
   rec1, rec2: CARDINAL ;
BEGIN
   rec1 := 1 ;
   rec2 := no ;
   QSort(rec1, rec2, Less, Swap)
END QuickSort ;


PROCEDURE QSort (Lower, Upper: CARDINAL; 
                 Less: LessProcType; Swap: SwapProcType) ;
VAR
   rec1, rec2, mid_point: CARDINAL ;
BEGIN
   rec1 := Lower ;
   rec2 := Upper ;
   mid_point := (rec1 + rec2) DIV 2 ;
   (* While there is a chunk to process *)
   WHILE rec1<=rec2 DO
      WHILE Less(rec1, mid_point) DO
         INC(rec1)
      END ; (* while *)
      WHILE Less(mid_point, rec2) DO
         DEC(rec2)
      END ; (* while *) 
      IF rec1<=rec2
      THEN
         Swap(rec1, rec2) ;
         INC(rec1) ;
         DEC(rec2)
      END (*if*)
   END ; (* while*)
   IF Lower<rec2
   THEN
      QSort(Lower, rec2, Less, Swap)
   END ; (*if*)
   IF rec1<Upper
   THEN
      QSort(rec1, Upper, Less, Swap)
   END (*if*)
END QSort ;


(*-------------------*)
PROCEDURE ShellSort(no: CARDINAL; Less: LessProcType; Swap: SwapProcType);
VAR
   Gap, i, j, k: INTEGER;
BEGIN
   Gap := (1 + no) DIV 2 ;
   WHILE Gap>0 DO
      FOR i := (Gap + 1) TO no DO
         j := i - Gap;
         WHILE j>0 DO
            k := j + Gap;
            IF Less(VAL(CARDINAL, j), VAL(CARDINAL, k))
            THEN
               j := 0
            ELSE
               Swap(VAL(CARDINAL, j), VAL(CARDINAL, k)) ;
               DEC(j, Gap)
            END (*If Else*)
         END (*While j>0*)
      END; (*For i*)
      Gap := Gap DIV 2
   END  (*While Gap >0*)
END ShellSort ;


END Sort.





