IMPLEMENTATION MODULE Storage ;


IMPORT SysStorage ;


(*
- Allocate some dynamic storage (contiguous memory area).

in:     Size    number of bytes to allocate,

out:    a       ADDRESS of allocated storage.
*)

PROCEDURE ALLOCATE (VAR a: ADDRESS ; Size: CARDINAL) ;
BEGIN
   SysStorage.ALLOCATE(a, Size)
END ALLOCATE ;


(*
- Release some dynamic storage (contiguous memory area).

in:     a       ADDRESS of the area to release,
        Size    number of bytes to be released,

out:    a       set to NIL.

The storage area released is made available for subsequent
calls to ALLOCATE.
*)

PROCEDURE DEALLOCATE (a: ADDRESS; Size: CARDINAL);
BEGIN
   SysStorage.DEALLOCATE(a, Size)
END DEALLOCATE ;


(*
- Test whether some number of bytes could be allocated.

in:     Size    number of bytes

out:    TRUE if ALLOCATE (p, Size) would succeed.
*)

PROCEDURE Available (Size: CARDINAL) : BOOLEAN;
BEGIN
   RETURN( SysStorage.Available(Size) )
END Available ;


END Storage.
