MODULE real5 ;

FROM StrIO IMPORT WriteString, WriteLn ;
FROM ASCII IMPORT nul ;

PROCEDURE Power10 (r: REAL; power: CARDINAL) : REAL;
VAR 
   i: CARDINAL;
BEGIN
   FOR i  := 1 TO power DO
      r := r * 10.0
   END ;
   RETURN( r )
END Power10 ;


(*
   WriteReal - writes a REAL number, Real, which has a, TotalWidth, and
               FractionWidth.
*)

PROCEDURE WriteReal (Real: REAL; TotalWidth, FractionWidth: CARDINAL) ;
CONST
   MaxInt   = 2147483647 ;
VAR
   integer, 
   int         : INTEGER;
   firstwidth,
   fieldwidth,
   integerwidth,
   digit,
   ccount, 
   count, 
   rcount      : CARDINAL;
   remainder   : REAL;
   neg         : BOOLEAN;
   FinalIndex  : CARDINAL ;
   Final,
   buf         : ARRAY [0..80] OF CHAR;
   MaxTrunc    : REAL ;
BEGIN
   MaxTrunc := FLOAT(MaxInt) ;
   neg := Real<0.0 ;
   IF neg
   THEN
      Real := -Real
   END;
   FOR count := 0 TO HIGH(buf) DO
      buf[count] := '0'
   END ;
   count := 0 ;
   REPEAT
      (* Divide it down until it can safely be TRUNCed	*)
      rcount := 0 ;
      WHILE Real >= MaxTrunc DO
         Real := Real / 10.0 ;
         INC(rcount) ;
      END ;

      (*  Now store the non-fractional digits *)
      integer := TRUNC(Real) ;
      int := integer ;
      ccount := 0 ;
      REPEAT
         buf[ccount+rcount] := CHR((CARDINAL (int MOD 10)) + ORD('0')) ;
         int := int DIV 10 ;
         INC(ccount)
      UNTIL int=0 ;
      IF count=0
      THEN
         count := rcount + ccount
      END ;

      (*  recover fractional part and restore to true significance *)
      remainder := Real - FLOAT(integer) ;
      Real := Power10 (remainder, rcount)
   UNTIL rcount = 0 ;

   IF neg
   THEN
      buf[count] := '-' ;
      INC(count)
   END ;

   integerwidth := count ;
   firstwidth := integerwidth ;

   IF FractionWidth>0
   THEN
      (*  make room for decimal point *)
      INC(firstwidth)
   END ;
   IF firstwidth>=TotalWidth
   THEN
      integerwidth := TotalWidth
   ELSE
      IF firstwidth+FractionWidth<TotalWidth
      THEN
         integerwidth := TotalWidth ;
         IF FractionWidth>0
         THEN
            DEC(integerwidth, FractionWidth+1)
         END
      END
   END ;

   FinalIndex := 0 ;
   fieldwidth := integerwidth ;
   WHILE fieldwidth>TotalWidth DO
      Final[FinalIndex] := ' ' ;
      INC(FinalIndex) ;
      DEC(fieldwidth)
   END ;
   REPEAT
      DEC(count);
      Final[FinalIndex] := buf[count] ;
      INC(FinalIndex)
   UNTIL count=0 ;
   IF integerwidth<TotalWidth
   THEN
      Final[FinalIndex] := '.' ;
      INC(FinalIndex) ;
      FOR count := integerwidth+2 TO TotalWidth DO
         remainder := remainder * 10.0;
         digit := TRUNC(remainder);
         remainder := remainder - FLOAT(digit) ;
         Final[FinalIndex] := CHR(ORD('0') + digit) ;
         INC(FinalIndex)
      END
   END ;
   Final[FinalIndex] := nul ;
   WriteString(Final)
END WriteReal ;


BEGIN
   WriteReal(3.1415927, 10, 7)
END real5.
